## khmer 2.1.2%2Bdfsg

=== examples/c++-api/Makefile ===
CXXFLAGS=--std=c++11 \
       -I ../../include/ \
	   -I ../../third-party/smhasher \
	   -I ../../third-party/seqan/core/include/

TESTS=exact-counting bloom consume

%: %.cc ../../src/oxli/liboxli.a
	$(CXX) $(CXXFLAGS) $< ../../src/oxli/liboxli.a -o $@ 

../../src/oxli/liboxli.a:
	cd ../../src/oxli && make

run: all
	./exact-counting
	./bloom
	./consume reads.fastq

all: $(TESTS)

clean:
	-rm -f exact-counting bloom consume

=== debian/changelog ===
khmer (2.1.2+dfsg-8) unstable; urgency=medium

  * Fix autopkgtests for newer pytest: s/pyarg/pyargs/
  * Standards-Version: 4.5.1 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Update renamed lintian tag names in lintian overrides.
  * Replace use of deprecated $ADTTMP with $AUTOPKGTEST_TMP.

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 04 Jan 2021 14:18:12 +0100

khmer (2.1.2+dfsg-7) unstable; urgency=medium

  * Simplify autopkgtest. Closes: #955566
  * s/ADTTMP/AUTOPKGTEST_TMP/g
  * Standards-Version: 4.5.0 (routine-update)
  * debhelper-compat 12 (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Use secure URI in Homepage field.
  * Remove obsolete fields Contact, Name from debian/upstream/metadata
    (already present in machine-readable debian/copyright).

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Tue, 07 Apr 2020 17:27:50 +0200

khmer (2.1.2+dfsg-6) unstable; urgency=medium

  * Fix building arch-independent packages separately.

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Wed, 09 Jan 2019 07:27:45 -0800

khmer (2.1.2+dfsg-5) unstable; urgency=medium

  * Fix liboxli-dev autopkgtest.
  * debian/khmer.metainfo.xml: Use a component ID in reverse domain-name
    format.
  * shrink khmer-common and silence many lintian warnings by symlinking to the
    relevant files in python3-guzzle-sphinx-theme

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Tue, 08 Jan 2019 06:16:30 -0800

khmer (2.1.2+dfsg-4) unstable; urgency=medium

  * Team upload.

  [ Michael R. Crusoe ]
  * deal with embedded-javascript-library.

  [ Andreas Tille ]
  * debhelper 11
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.3.0
  * Drop useless get-orig-source target
  * Respect DEB_BUILD_OPTIONS in override_dh_auto_test target
  * Drop ancient X-Python-Version field
  * package khmer is: Multi-Arch: foreign

 -- Andreas Tille <tille@debian.org>  Mon, 07 Jan 2019 15:22:24 +0100

khmer (2.1.2+dfsg-3) unstable; urgency=medium

  * Drop unsupported archs (mips*, ppc*).

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Sun, 11 Feb 2018 02:20:06 -0800

khmer (2.1.2+dfsg-2) unstable; urgency=medium

  * Team upload
  * debhelper 10
  * Specify compression option from d/rules directly inside watch file
  * Fix clean target ba removing possibly existing __pycache__ and .eggs
  * Autopkgtest is making use of third-party header file - install this into
    liboxli-dev package and add according -I directive to test
    Closes: #851830
  * Standards-Version: 4.1.2

 -- Andreas Tille <tille@debian.org>  Fri, 15 Dec 2017 19:42:24 +0100

khmer (2.1.2+dfsg-1) unstable; urgency=medium

  * New upstream version 2.1.2

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Sat, 07 Oct 2017 05:47:31 -0700

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,filenamemangle=s/(?:.*?)?v?(\d[\d.]*)\.tar\.gz/khmer-$1.tar.gz/,repack,compression=xz" \
  https://github.com/dib-lab/khmer/releases .*/archive/v?(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## khmer 2.1.2+dfsg

=== Makefile ===
# This file is part of khmer, https://github.com/dib-lab/khmer/, and is
# Copyright (C) 2010-2015, Michigan State University.
# Copyright (C) 2015-2016, The Regents of the University of California.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#
#     * Redistributions in binary form must reproduce the above
#       copyright notice, this list of conditions and the following
#       disclaimer in the documentation and/or other materials provided
#       with the distribution.
#
#     * Neither the name of the Michigan State University nor the names
#       of its contributors may be used to endorse or promote products
#       derived from this software without specific prior written
#       permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# Contact: khmer-project@idyll.org

# `make help` for a summary of useful targets

# `SHELL=bash` Will break Titus's laptop, so don't use BASH-isms like
# `[[` conditional expressions.
#
PREFIX=/usr/local
CPPSOURCES=$(wildcard src/oxli/*.cc include/oxli/*.hh src/khmer/_cpy_*.cc include/khmer/_cpy_*.hh) setup.py
CYSOURCES=$(wildcard khmer/_oxli/*.pxd khmer/_oxli/*.pyx)
PYSOURCES=$(filter-out khmer/_version.py, \
	  $(wildcard khmer/*.py scripts/*.py oxli/*.py) )
SOURCES=$(PYSOURCES) $(CPPSOURCES) $(CYSOURCES) setup.py

DEVPKGS=pep8==1.6.2 diff_cover autopep8 pylint coverage gcovr pytest \
	'pytest-runner>=2.0,<3dev' pydocstyle pyenchant

GCOVRURL=git+https://github.com/nschum/gcovr.git@never-executed-branches

VERSION=$(shell ./setup.py version | grep Version | awk '{print $$4}' \
	| sed 's/+/-/')

# The following four variables are only used by cppcheck. If you want to
# change how things are compiled edit `setup.cfg` or `setup.py`.
DEFINES += -DNDEBUG -DVERSION=$(VERSION) -DSEQAN_HAS_BZIP2=1 \
	   -DSEQAN_HAS_ZLIB=1 -UNO_UNIQUE_RC

INCLUDESTRING=$(shell gcc -E -x c++ - -v < /dev/null 2>&1 >/dev/null \
	    | grep '^ /' | grep -v cc1plus)
INCLUDEOPTS=$(shell gcc -E -x c++ - -v < /dev/null 2>&1 >/dev/null \
	    | grep '^ /' | grep -v cc1plus | awk '{print "-I" $$1 " "}')

PYINCLUDE=$(shell python -c "from __future__ import print_function; \
	    import sysconfig; flags = ['-I' + sysconfig.get_path('include'), \
	    '-I' + sysconfig.get_path('platinclude')]; print(' '.join(flags))")

CPPCHECK_SOURCES=$(filter-out lib/test%, $(wildcard lib/*.cc khmer/_khmer.cc) )
CPPCHECK=cppcheck --enable=all \
	 --error-exitcode=1 \
	 --suppress='*:/Library/*' \
	 --suppress='*:*/include/python*/Python.h' \
	 --suppress='*:/usr/*' --platform=unix64 \
	 --std=c++11 --inline-suppr -Ilib -Ithird-party/bzip2 \
	 -Ithird-party/zlib -Ithird-party/smhasher \
	 $(DEFINES) $(INCLUDEOPTS) $(PYINCLUDE) $(CPPCHECK_SOURCES) --quiet

UNAME := $(shell uname)
ifeq ($(UNAME),Linux)
	TESTATTR ?= 'not known_failing and not jenkins and not huge'
else
	TESTATTR ?= 'not known_failing and not jenkins and not huge and not linux'
endif

MODEXT=$(shell python -c \
       "import sysconfig;print(sysconfig.get_config_var('SO'))")
EXTENSION_MODULE = khmer/_khmer$(MODEXT)
CY_MODULES = $($(wildcard khmer/_oxli/*.pyx): .pyx=.$(MODEXT))

PYLINT_TEMPLATE="{path}:{line}: [{msg_id}({symbol}), {obj}] {msg}"

## all         : default task; compile C++ code, build shared object library
all: sharedobj

## help        : print this help message and exit
help: Makefile
	@sed -n 's/^##//p' $<

## install-dep : install most of the development dependencies via pip
install-dep: install-dependencies

install-dependencies:
	pip install --upgrade --ignore-installed $(DEVPKGS)
	pip install --upgrade --requirement doc/requirements.txt

## sharedobj   : build khmer shared object file
sharedobj: $(EXTENSION_MODULE)

$(EXTENSION_MODULE): $(CPPSOURCES) $(CYSOURCES)
	./setup.py build_ext --inplace

coverage-debug: $(CPPSOURCES)
	export CFLAGS="-pg -fprofile-arcs -ftest-coverage -O0"; ./setup.py \
		build_ext --debug --inplace --libraries gcov
	touch coverage-debug

## install     : install the khmer module and scripts
install: FORCE
	./setup.py build install

## dist        : create a module package for distribution
dist: dist/khmer-$(VERSION).tar.gz

dist/khmer-$(VERSION).tar.gz: $(SOURCES)
	./setup.py sdist

## clean       : clean up all temporary / machine-generated files
clean: FORCE
	cd src/oxli && $(MAKE) clean || true
	cd tests && rm -rf khmertest_* || true
	rm -f pytests.xml
	rm -f $(EXTENSION_MODULE)
	rm -f khmer/*.pyc scripts/*.pyc tests/*.pyc oxli/*.pyc \
		sandbox/*.pyc khmer/__pycache__/* sandbox/__pycache__/* \
		khmer/_oxli/*.cpp
	./setup.py clean --all || true
	rm -f coverage-debug
	rm -Rf .coverage coverage-gcovr.xml coverage.xml
	rm -f diff-cover.html
	rm -Rf build dist
	rm -rf __pycache__/ khmer.egg-info/
	@find ./ -type d -name __pycache__ -exec rm -rf {} +
	@find ./khmer/ -type f -name *$(MODEXT) -exec rm -f {} +
	-rm -f *.gcov

debug: FORCE
	export CFLAGS="-pg -fprofile-arcs -D_GLIBCXX_DEBUG_PEDANTIC \
		-D_GLIBCXX_DEBUG -DDEBUG_ASSEMBLY=1 -DDEBUG_FILTERS=1"; python setup.py build_ext --debug \
		--inplace

## doc         : render documentation in HTML
doc: build/sphinx/html/index.html

build/sphinx/html/index.html: $(SOURCES) $(wildcard doc/*.rst) doc/conf.py all
	./setup.py build_sphinx --fresh-env
	@echo ''
	@echo '--> docs in build/sphinx/html <--'
	@echo ''

## pdf         : render documentation as a PDF file
# packages needed include: texlive-latex-base texlive-latex-recommended
# texlive-fonts-recommended texlive-latex-extra
pdf: build/sphinx/latex/khmer.pdf

build/sphinx/latex/khmer.pdf: $(SOURCES) doc/conf.py $(wildcard doc/*.rst) \
	$(wildcard doc/user/*.rst) $(wildcard doc/dev/*.rst) sharedobj
	./setup.py build_sphinx --fresh-env --builder latex
	cd build/sphinx/latex && $(MAKE) all-pdf
	@echo ''
	@echo '--> pdf in build/sphinx/latex/khmer.pdf'

cppcheck-result.xml: $(CPPSOURCES)
	$(CPPCHECK) --xml-version=2 2> cppcheck-result.xml

## cppcheck    : run static analysis on C++ code
cppcheck: FORCE
	@$(CPPCHECK)

cppcheck-long: FORCE
	@$(CPPCHECK) -Ithird-party/seqan/core/include

## pep8        : check Python code style
pep8: $(PYSOURCES) $(wildcard tests/*.py)
	pep8 setup.py khmer/*.py scripts/*.py tests/*.py oxli/*.py

pep8_report.txt: $(PYSOURCES) $(wildcard tests/*.py)
	pep8 setup.py khmer/ scripts/ tests/ oxli/ \
		> pep8_report.txt || true

diff_pep8_report: pep8_report.txt
	diff-quality --violations=pep8 pep8_report.txt

## pydocstyle  : check Python doc strings
pydocstyle: $(PYSOURCES) $(wildcard tests/*.py)
	pydocstyle --ignore=D100,D101,D102,D103,D203 --match='(?!_version).*\.py' \
		setup.py khmer/ scripts/ oxli/ || true

pydocstyle_report.txt: $(PYSOURCES) $(wildcard tests/*.py)
	pydocstyle setup.py khmer/ scripts/ tests/ oxli/ \
		> pydocstyle_report.txt 2>&1 || true

diff_pydocstyle_report: pydocstyle_report.txt
	diff-quality --violations=pep8 pydocstyle_report.txt

## astyle      : fix most C++ code indentation and formatting
astyle: $(CPPSOURCES)
	astyle -A10 --max-code-length=80 $(filter-out setup.py,$(CPPSOURCES))

## autopep8    : fix most Python code indentation and formatting
autopep8: $(PYSOURCES) $(wildcard tests/*.py)
	autopep8 --recursive --in-place --exclude _version.py --ignore E309 \
		setup.py khmer/*.py scripts/*.py tests/*.py oxli/*.py

## format      : check/fix all code formatting (astyle and autopep8)
format: astyle autopep8
	# Do nothing

## pylint      : run static code analysis on Python code
pylint: $(PYSOURCES) $(wildcard tests/*.py)
	pylint --msg-template=$(PYLINT_TEMPLATE) \
		setup.py $(PYSOURCES) tests/*.py || true

pylint_report.txt: $(PYSOURCES) $(wildcard tests/*.py) $(wildcard sandbox/*.py)
	pylint --msg-template=$(PYLINT_TEMPLATE) \
		$(PYSOURCES) tests sandbox > pylint_report.txt || true

diff_pylint_report: pylint_report.txt
	diff-quality --violations=pylint pylint_report.txt

# We need to get coverage to look at our scripts. Since they aren't in a
# python module we can't tell pytest to look for them (via an import
# statement). So we run pytest inside of coverage.
.coverage: $(PYSOURCES) $(wildcard tests/*.py) $(EXTENSION_MODULE)
	./setup.py develop
	coverage run --branch --source=scripts,khmer,oxli \
		--omit=khmer/_version.py -m pytest --junitxml=pytests.xml \
		-m $(TESTATTR)

coverage.xml: .coverage
	coverage xml

coverage.html: htmlcov/index.html

htmlcov/index.html: .coverage
	coverage html
	@echo Test coverage of the Python code is now in htmlcov/index.html

coverage-report: .coverage
	coverage report

coverage-gcovr.xml: coverage-debug .coverage
	gcovr --root=. --branches --output=coverage-gcovr.xml --xml \
          --gcov-exclude='.*zlib.*|.*bzip2.*|.*smhasher.*|.*seqan.*' \
	  --exclude-unreachable-branches

diff-cover: coverage-gcovr.xml coverage.xml
	diff-cover coverage-gcovr.xml coverage.xml

diff-cover.html: coverage-gcovr.xml coverage.xml
	diff-cover coverage-gcovr.xml coverage.xml \
		--html-report diff-cover.html

pytests.xml: FORCE
	py.test --junitxml=$@ -m ${TESTATTR}

## doxygen     : generate documentation of the C++ and Python code
# helpful packages: doxygen graphviz
# ignore warning re: _formulas.aux
doxygen: doc/doxygen/html/index.html

doc/doxygen/html/index.html: $(CPPSOURCES) $(PYSOURCES)
	mkdir -p doc/doxygen
	sed "s=\$${VERSION}=$(VERSION)=" Doxyfile.in | \
		sed "s=\$${INCLUDES}=$(INCLUDESTRING)=" > Doxyfile
	doxygen

liboxli: FORCE
	cd src/oxli && \
	$(MAKE)

install-liboxli: liboxli
	cd src/oxli && $(MAKE) install PREFIX=$(PREFIX)
	mkdir -p $(PREFIX)/include/khmer
	cp -r include/khmer/_cpy_*.hh $(PREFIX)/include/khmer/

# Runs a test of liboxli
libtest: FORCE
	rm -rf install_target
	mkdir -p install_target
	cd src/oxli && \
	 $(MAKE) clean && \
	 $(MAKE) all && \
	 $(MAKE) install PREFIX=../install_target
	test -d install_target/include
	test -f install_target/include/oxli/oxli.hh
	test -d install_target/lib
	test -f install_target/lib/liboxli.a
	$(CXX) -std=c++11 -o install_target/test-prog-static \
		-I install_target/include src/oxli/test-compile.cc \
		install_target/lib/liboxli.a
	$(CXX) -std=c++11 -o install_target/test-prog-dynamic \
		-I install_target/include -L install_target/lib \
		src/oxli/test-compile.cc -loxli
	rm -rf install_target

## test        : run the khmer test suite
test: FORCE
	./setup.py develop
	py.test -m ${TESTATTR}

sloccount.sc: $(CPPSOURCES) $(PYSOURCES) $(wildcard tests/*.py) Makefile
	sloccount --duplicates --wide --details include src khmer scripts tests \
		setup.py Makefile > sloccount.sc

## sloccount   : count lines of code
sloccount:
	sloccount src include khmer scripts tests setup.py Makefile

coverity-build:
	if [ -x "${cov_analysis_dir}/bin/cov-build" ]; \
	then \
		export PATH=${PATH}:${cov_analysis_dir}/bin; \
		cov-build --dir cov-int --c-coverage gcov \
			--disable-gcov-arg-injection make coverage-debug; \
		cov-capture --dir cov-int --c-coverage gcov python -m pytest \
			-m $(TESTATTR) ; \
		cov-import-scm --dir cov-int --scm git 2>/dev/null; \
	else echo 'bin/cov-build does not exist in $$cov_analysis_dir: '\
		'${cov_analysis_dir}. Skipping coverity scan.'; \
	fi

=== doc/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d _build/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml pickle json htmlhelp qthelp latex changes linkcheck doctest

all: html

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html      to make standalone HTML files"
	@echo "  dirhtml   to make HTML files named index.html in directories"
	@echo "  pickle    to make pickle files"
	@echo "  json      to make JSON files"
	@echo "  htmlhelp  to make HTML files and a HTML help project"
	@echo "  qthelp    to make HTML files and a qthelp project"
	@echo "  latex     to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  changes   to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck to check all external links for integrity"
	@echo "  doctest   to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf _build/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) _build/html
	@echo
	@echo "Build finished. The HTML pages are in _build/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) _build/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in _build/dirhtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) _build/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) _build/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) _build/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in _build/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) _build/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in _build/qthelp, like this:"
	@echo "# qcollectiongenerator _build/qthelp/khmer.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile _build/qthelp/khmer.qhc"

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) _build/latex
	@echo
	@echo "Build finished; the LaTeX files are in _build/latex."
	@echo "Run \`make all-pdf' or \`make all-ps' in that directory to" \
	      "run these through (pdf)latex."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) _build/changes
	@echo
	@echo "The overview file is in _build/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) _build/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in _build/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) _build/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in _build/doctest/output.txt."

=== doc/requirements.txt ===
sphinxcontrib-autoprogram==0.1.2
setuptools>=3.4.1
guzzle_sphinx_theme==0.7.11
Cython>=0.25.2

=== src/oxli/Makefile ===
# This file is part of khmer, https://github.com/dib-lab/khmer/, and is
# Copyright (C) 2010-2015, Michigan State University.
# Copyright (C) 2015, The Regents of the University of California.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#
#     * Redistributions in binary form must reproduce the above
#       copyright notice, this list of conditions and the following
#       disclaimer in the documentation and/or other materials provided
#       with the distribution.
#
#     * Neither the name of the Michigan State University nor the names
#       of its contributors may be used to endorse or promote products
#       derived from this software without specific prior written
#       permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# Contact: khmer-project@idyll.org

# Should we use the standard system zlib and libbz2?

USE_SYSTEM_ZLIB ?= false
USE_SYSTEM_LIBBZ2 ?= false

# Profile?
# Set this variable to true if you wish to profile the codes.
WANT_PROFILING=false

# Which profiling tool to use?
# Assuming you have TAU installed and setup properly,
# you can instrument codes with it to get detailed multi-threaded profiling.
# Otherwise, gprof is able to give you some information without threading info.
# Choose one of: gprof, TAU
PROFILER_OF_CHOICE=gprof

# Perform extra sanity checking?
# Set this variable to true
# if you wish the codes to perform extra sanity checking
# (to the possible detriment of performance).
WANT_EXTRA_SANITY_CHECKING=false

# Compile with debugging symbols?
# Set this variable to true
# if you wish the codes to be built with debugging symbols
# (increases code size
# and does not always produce accurate stepping in a debugger
# when optimization is turned on).
WANT_DEBUGGING=false

PREFIX=/usr/local

### NOTE: No user-serviceable parts below this line! ###

INCLUDES= -I ../../include/ -I ../../third-party/seqan/core/include/ \
	      -I ../../third-party/smhasher/

ifeq ($(USE_SYSTEM_ZLIB), false)
INCLUDES += -I ../../third-party/zlib/
endif

ifeq ($(USE_SYSTEM_LIBBZ2), false)
INCLUDES += -I ../../third-party/bzip2/
endif

# Warnings in common to C and C++
WARNINGS=-Wall

# Flags in common to C and C++
COMMON_FLAGS=-O3 -fPIC
SEQAN_FLAGS=-DSEQAN_HAS_ZLIB=1 -DSEQAN_HAS_BZIP2=1

# Base C/CXXFLAGS
CPPFLAGS ?=
CPPFLAGS += $(SEQAN_FLAGS)

CXXFLAGS ?=
CXXFLAGS += $(COMMON_FLAGS) $(WARNINGS)
CXXFLAGS += -Wstrict-null-sentinel -std=c++11
CXXFLAGS += $(INCLUDES) $(CPPFLAGS)

CFLAGS	 ?=
CXXFLAGS += $(COMMON_FLAGS) $(WARNINGS)
CFLAGS   += -Wshadow -Wcast-align -Wstrict-prototypes
CFLAGS   += $(INCLUDES) $(CPPFLAGS)

LDFLAGS  ?=
ifneq ($(USE_SYSTEM_ZLIB), false)
LDFLAGS  += -lz
endif

ifneq ($(USE_SYSTEM_LIBBZ2), false)
LDFLAGS  += -lbz2
endif

ifeq ($(WANT_DEBUGGING), true)
DEBUG_FLAGS=-g
CXXFLAGS += $(DEBUG_FLAGS)
CFLAGS   += $(DEBUG_FLAGS)
endif

ifeq ($(WANT_EXTRA_SANITY_CHECKING), true)
DEFINE_OXLI_EXTRA_SANITY_CHECKS=-DOXLI_EXTRA_SANITY_CHECKS
CXXFLAGS += $(DEFINE_OXLI_EXTRA_SANITY_CHECKS)
CFLAGS   += $(DEFINE_OXLI_EXTRA_SANITY_CHECKS)
endif

ifeq ($(WANT_PROFILING), true)
ifeq ($(PROFILER_OF_CHOICE), TAU)
CXX=tau_cxx.sh
endif
ifeq ($(PROFILER_OF_CHOICE), gprof)
CXXFLAGS += -pg
CFLAGS   += -pg
LDFLAGS  += -pg
endif
endif

# Place POSIX threads last in linking order, if needed.
ifneq ($(shell uname), Linux)
LDFLAGS  += -pthread
endif


HAVE_OPENMP=$(shell 						\
	      $(CXX) -fopenmp -o chkomp .check_openmp.cc 	\
	      2>/dev/null && echo true || echo false; 		\
	      rm -f chkomp)

ifeq ($(HAVE_OPENMP), true)
CXXFLAGS +=-fopenmp
CFLAGS   +=-fopenmp
endif

ifneq ($(PACKAGE_VERSION),)
VERSION = $(PACKAGE_VERSION)
else
VERSION = $(./setup.py version | grep Version | awk '{print $2}')
endif

# The ABI version of liboxli
LIB_VERSION = 1

ifeq ($(shell uname), Darwin)
SHARED_EXT   = dylib
SONAME       = liboxli.$(SHARED_EXT).$(LIB_VERSION)
SONAME_FLAGS = -install_name $(PREFIX)/lib/$(SONAME) \
	       -compatibility_version $(LIB_VERSION) \
	       -current_version $(LIB_VERSION)
else
SHARED_EXT   = so
SONAME       = liboxli.$(SHARED_EXT).$(LIB_VERSION)
SONAME_FLAGS = -Wl,-soname=$(SONAME)
endif

LIBOXLISO=$(SONAME)

CXXFLAGS += -DVERSION=$(VERSION)

NO_UNIQUE_RC=0
CXXFLAGS += -DNO_UNIQUE_RC=$(NO_UNIQUE_RC)
CFLAGS   += -DNO_UNIQUE_RC=$(NO_UNIQUE_RC)

export CXX
export CFLAGS
export CXXFLAGS
export LDFLAGS
export VERSION


#### Third party dependencies ####
# ZLIB, use .lo not .o, so we get -fPIC and other library-related flags
ZLIB_DIR=../../third-party/zlib
ZLIB_OBJS_BASE=\
	adler32.lo \
	crc32.lo \
	deflate.lo \
	infback.lo \
	inffast.lo \
	inflate.lo \
	inftrees.lo \
	trees.lo \
	zutil.lo \
	compress.lo \
	uncompr.lo \
	gzclose.lo \
	gzlib.lo \
	gzread.lo \
	gzwrite.lo

ZLIB_OBJS=$(addprefix $(ZLIB_DIR)/, $(ZLIB_OBJS_BASE))

# BZ2
BZIP2_DIR=../../third-party/bzip2
BZIP2_OBJS_BASE= \
	blocksort.o \
	huffman.o \
	crctable.o \
	randtable.o \
	compress.o \
	decompress.o \
	bzlib.o

BZIP2_OBJS=$(addprefix $(BZIP2_DIR)/, $(BZIP2_OBJS_BASE))


#### oxli proper below here ####

LIBOXLI_OBJS= \
	hashtable.o \
	hashgraph.o \
	hllcounter.o \
	kmer_hash.o \
	labelhash.o \
	traversal.o \
	read_aligner.o \
	read_parsers.o \
	subset.o \
	kmer_filters.o \
	assembler.o \
	alphabets.o \
	murmur3.o \
	storage.o

PRECOMILE_OBJS ?=
PRECLEAN_TARGS ?=

ifeq ($(USE_SYSTEM_ZLIB), false)
LIBOXLI_OBJS  += $(ZLIB_OBJS)
PRECOMILE_OBJS += $(ZLIB_OBJS)
PRECLEAN_TARGS += zlibclean
endif

ifeq ($(USE_SYSTEM_LIBBZ2), false)
LIBOXLI_OBJS  += $(BZIP2_OBJS)
PRECOMILE_OBJS += $(BZIP2_OBJS)
PRECLEAN_TARGS += libbz2clean
endif

HEADERS= \
	hashtable.hh \
	hashgraph.hh \
	hllcounter.hh \
	oxli_exception.hh \
	oxli.hh \
	kmer_hash.hh \
	labelhash.hh \
	traversal.hh \
	read_aligner.hh \
	read_parsers.hh \
	subset.hh \
	kmer_filters.hh \
	assembler.hh \
	alphabets.hh \
	storage.hh
OXLI_HEADERS = $(addprefix ../../include/oxli/,$(HEADERS))

# START OF RULES #

# The all rule comes first!
all: $(LIBOXLISO) liboxli.a oxli.pc

zlibclean:
	(cd $(ZLIB_DIR) && make distclean)
libbz2clean:
	(cd $(BZIP2_DIR) && make -f Makefile-libbz2_so clean)

clean: $(PRECLEAN_TARGS)
	rm -f *.o *.a *.$(SHARED_EXT)* oxli.pc $(TEST_PROGS)

install: $(LIBOXLISO) liboxli.a oxli.pc $(OXLI_HEADERS)
	rm -rf $(PREFIX)/include/oxli $(PREFIX)/include/khmer
	mkdir -p $(PREFIX)/lib $(PREFIX)/lib/pkgconfig $(PREFIX)/include/oxli
	cp -r $(OXLI_HEADERS) 				\
		../../third-party/smhasher/MurmurHash3.h 	\
		$(PREFIX)/include/oxli/
	cp oxli.pc $(PREFIX)/lib/pkgconfig/
	cp $(LIBOXLISO) liboxli.a $(PREFIX)/lib/
	ln -sf $(PREFIX)/lib/$(LIBOXLISO) $(PREFIX)/lib/liboxli.$(SHARED_EXT)

oxli.pc: oxli.pc.in
	sed -e 's,@prefix@,$(PREFIX),'  -e 's,@VERSION@,$(VERSION),' $< >$@

$(ZLIB_OBJS):
	(cd $(ZLIB_DIR) && ./configure && make $(ZLIB_OBJS_BASE))

$(BZIP2_OBJS):
	(cd $(BZIP2_DIR) && make -f Makefile-libbz2_so $(BZIP2_OBJS_BASE))

# MurMur3
murmur3.o: ../../third-party/smhasher/MurmurHash3.cc
	$(CXX) $(CXXFLAGS) -c -o $@ $<

%.o: %.cc $(PRECOMILE_OBJS) $(OXLI_HEADERS)
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -c -o $@ $<

$(LIBOXLISO): $(LIBOXLI_OBJS)
	$(CXX) $(CXXFLAGS) $(LDFLAGS) $(SONAME_FLAGS) -shared -o $@ $^
	ln -sf $(SONAME) liboxli.$(SHARED_EXT)

liboxli.a: $(LIBOXLI_OBJS)
	ar rcs $@ $^
	ranlib $@

=== debian/changelog ===
khmer (2.1.2+dfsg-6build2) focal; urgency=medium

  * No-change rebuild to drop python3.7.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 18 Feb 2020 09:27:24 +0100

khmer (2.1.2+dfsg-6build1) focal; urgency=medium

  * No-change rebuild to build with python3.8.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 18 Oct 2019 18:41:07 +0000

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE=1
export PYBUILD_NAME=khmer
export PYBUILD_INSTALL_ARGS='--install-scripts=/usr/lib/khmer/bin'
export PYBUILD_DESTDIR_python3=debian/khmer
export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow
export DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
# Force C++ library build to use Debian zlib1g-dev/libbz2-dev
export USE_SYSTEM_ZLIB=true
export USE_SYSTEM_LIBBZ2=true

export HOME=$(shell echo $$PWD"/fakehome")

%:
	dh $@ --with python3,sphinxdoc --buildsystem=pybuild

override_dh_auto_build:
	dh_auto_build
	ln -sf "`pwd`"/.pybuild/pythonX.Y_*/build/khmer/*.so khmer && \
		./setup.py develop --user && ./setup.py build_sphinx
	asciidoctor --backend manpage -a reproducible debian/khmer.1.adoc
	cd src/oxli && $(MAKE) clean all

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_install
	PYBUILD_SYSTEM=custom \
	    PYBUILD_TEST_ARGS="cd {dir}; export PATH={destdir}/usr/lib/khmer/bin:$$PATH ; \
	    cd {build_dir}; export PYTHONPATH=$$(pwd); {interpreter} -m pytest \
	    -m 'not known_failing and not jenkins and not huge and not noroot'\
	    -q" dh_auto_test
endif

override_dh_auto_clean:
	dh_auto_clean || /bin/true
	cd src/oxli && $(MAKE) clean
	rm -rf __pycache__ .eggs

override_dh_install:
	cd src/oxli && $(MAKE) PREFIX=../debian/tmp install
	dh_install
	find debian/khmer -name .gitignore -delete

override_dh_sphinxdoc:
	dh_sphinxdoc
	rdfind -makesymlinks true -followsymlinks true\
		/usr/lib/python3/dist-packages/guzzle_sphinx_theme \
		$(shell find debian/khmer-common | grep -i -v citation)
	if [ -f debian/khmer-common/usr/share/doc/khmer-common/html/_sources/citations.rst.txt ]; then \
	  rm debian/khmer-common/usr/share/doc/khmer-common/html/_sources/citations.rst.txt && \
	  cd debian/khmer-common/usr/share/doc/khmer-common/html/_sources/ && \
		ln -s ../../CITATION citations.rst.txt; fi

=== debian/tests/control ===
Tests: run-unit-test
       test-liboxli-dev
Depends: khmer,python3-pytest,python3-pytest-runner,build-essential,pkg-config,zlib1g-dev,libbz2-dev,liboxli-dev
Restrictions: allow-stderr

## khmer 3.0.0~a3%2Bdfsg

=== debian/changelog ===
khmer (3.0.0~a3+dfsg-8) unstable; urgency=medium

  * d/patches/nose2pytest: rename setup/teardown methods to Pytest way.
    Closes: #1063977.

 -- Michael R. Crusoe <crusoe@debian.org>  Sat, 17 Feb 2024 12:38:43 +0100

khmer (3.0.0~a3+dfsg-7) unstable; urgency=medium

  * Team upload.
  * Refresh d/p/python3.12-support.patch with missing Ubuntu changes.

 -- Olivier Gayot <olivier.gayot@canonical.com>  Wed, 29 Nov 2023 21:57:29 +0100

khmer (3.0.0~a3+dfsg-6) unstable; urgency=medium

  * Team upload.

  [ Olivier Gayot ]
  * Add support for Python 3.12
    Closes: #1055687 (LP: #2044383)

  [ Andreas Tille ]
  * Build-Depends: s/dh-python/dh-sequence-python3/ (routine-update)

 -- Andreas Tille <tille@debian.org>  Wed, 29 Nov 2023 15:51:50 +0100

khmer (3.0.0~a3+dfsg-5) unstable; urgency=medium

  * Team Upload.
  * Use sphinx-build since build_sphinx option is
    removed (Closes: #1042657)
  * Bump Standards-Version to 4.6.2 (no changes needed)

 -- Nilesh Patra <nilesh@debian.org>  Sat, 09 Sep 2023 13:03:41 +0530

khmer (3.0.0~a3+dfsg-4) unstable; urgency=medium

  * Team Upload.
  * Add patch to find object files at the right location (Closes: #1020031)
  * d/rules: split oxli make rules into two, pass parameters/env-vars to not
    over-clean for make-all call

 -- Nilesh Patra <nilesh@debian.org>  Sat, 24 Sep 2022 21:04:43 +0530

khmer (3.0.0~a3+dfsg-3) unstable; urgency=medium

  * debian/control: stop building on no-amd64 due to use of assembly
    in third_party/cqf

 -- Michael R. Crusoe <crusoe@debian.org>  Fri, 02 Sep 2022 13:58:03 +0200

khmer (3.0.0~a3+dfsg-2) unstable; urgency=medium

  * debian/patches/fix_non_x86_build: enable building on aarch64 and
    other non-x86 systems.
  * debian/patches/hardening: Restore standard build flags into third-
    party/cqf.

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 01 Sep 2022 16:14:43 +0200

khmer (3.0.0~a3+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Refreshed patches
  * Added patch to run Cython so we can support Python 3.10+
  * Forwarded most patches upstream
  * Remove trailing whitespace in debian/changelog (routine-update)

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 30 Aug 2022 19:41:55 +0200

khmer (2.1.2+dfsg-11) unstable; urgency=medium

  [ Stefano Rivera ]
  * Adapt to a change in Python3
    Closes: #1008402

  [ Michael R. Crusoe ]
  * debian/patches: some header cleanups.
  * debian/patches/stringio-buffer.patch: another fix for recent Python
    versions.
  * Fix license mismatch in AppStream metadata
  * Standards-Version: 4.6.1 (routine-update)

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 22 Aug 2022 11:53:48 +0200

khmer (2.1.2+dfsg-10) unstable; urgency=medium

  * Team upload.
  * Use python-bz2 instead of bz2file (addressing bug #987287)
  * Standards-Version: 4.6.0 (routine-update)

 -- Andreas Tille <tille@debian.org>  Fri, 03 Dec 2021 21:59:39 +0100

khmer (2.1.2+dfsg-9) unstable; urgency=medium

  [ Nilesh Patra ]
  * Team Upload.
  * debian/patches/gcc11.patch: Fix gcc-11 FTBFS (Closes: #984079)
  * d/salsa-ci.yml: Disable reprotest and i386 build
  * d/clean: Clean more files

  [ Steffen Moeller ]
  * Fix watchfile to detect new versions on github (routine-update)

 -- Nilesh Patra <nilesh@debian.org>  Mon, 06 Sep 2021 14:34:23 +0000

## khmer 3.0.0~a3+dfsg

=== Makefile ===
--- 
+++ 
@@ -45,8 +45,7 @@
 	  $(wildcard khmer/*.py scripts/*.py oxli/*.py) )
 SOURCES=$(PYSOURCES) $(CPPSOURCES) $(CYSOURCES) setup.py
 
-DEVPKGS=pep8==1.6.2 diff_cover autopep8 pylint coverage gcovr pytest \
-	'pytest-runner>=2.0,<3dev' pydocstyle pyenchant
+DEVPKGS=pep8==1.6.2 diff_cover autopep8 pylint coverage gcovr pytest pydocstyle
 
 GCOVRURL=git+https://github.com/nschum/gcovr.git@never-executed-branches
 
@@ -63,9 +62,9 @@
 INCLUDEOPTS=$(shell gcc -E -x c++ - -v < /dev/null 2>&1 >/dev/null \
 	    | grep '^ /' | grep -v cc1plus | awk '{print "-I" $$1 " "}')
 
-PYINCLUDE=$(shell python -c "from __future__ import print_function; \
-	    import sysconfig; flags = ['-I' + sysconfig.get_path('include'), \
-	    '-I' + sysconfig.get_path('platinclude')]; print(' '.join(flags))")
+PYINCLUDE=$(shell python -c "import sysconfig; \
+            flags = ['-I' + sysconfig.get_path('include'), \
+            '-I' + sysconfig.get_path('platinclude')]; print(' '.join(flags))")
 
 CPPCHECK_SOURCES=$(filter-out lib/test%, $(wildcard lib/*.cc khmer/_khmer.cc) )
 CPPCHECK=cppcheck --enable=all \
@@ -74,7 +73,7 @@
 	 --suppress='*:*/include/python*/Python.h' \
 	 --suppress='*:/usr/*' --platform=unix64 \
 	 --std=c++11 --inline-suppr -Ilib -Ithird-party/bzip2 \
-	 -Ithird-party/zlib -Ithird-party/smhasher \
+	 -Ithird-party/zlib -Ithird-party/smhasher -Ithird-party/rollinghash \
 	 $(DEFINES) $(INCLUDEOPTS) $(PYINCLUDE) $(CPPCHECK_SOURCES) --quiet
 
 UNAME := $(shell uname)
@@ -102,8 +101,8 @@
 install-dep: install-dependencies
 
 install-dependencies:
-	pip install --upgrade --ignore-installed $(DEVPKGS)
-	pip install --upgrade --requirement doc/requirements.txt
+	pip install $(DEVPKGS)
+	pip install --requirement doc/requirements.txt
 
 ## sharedobj   : build khmer shared object file
 sharedobj: $(EXTENSION_MODULE)
@@ -131,10 +130,11 @@
 	cd src/oxli && $(MAKE) clean || true
 	cd tests && rm -rf khmertest_* || true
 	rm -f pytests.xml
+	cd third-party/cqf && make clean || true
 	rm -f $(EXTENSION_MODULE)
 	rm -f khmer/*.pyc scripts/*.pyc tests/*.pyc oxli/*.pyc \
 		sandbox/*.pyc khmer/__pycache__/* sandbox/__pycache__/* \
-		khmer/_oxli/*.cpp
+		khmer/_oxli/*.so
 	./setup.py clean --all || true
 	rm -f coverage-debug
 	rm -Rf .coverage coverage-gcovr.xml coverage.xml
@@ -183,7 +183,7 @@
 
 ## pep8        : check Python code style
 pep8: $(PYSOURCES) $(wildcard tests/*.py)
-	pep8 setup.py khmer/*.py scripts/*.py tests/*.py oxli/*.py
+	pep8 setup.py khmer/*.py scripts/*.py tests/*.py oxli/*.py examples/python-api/*.py
 
 pep8_report.txt: $(PYSOURCES) $(wildcard tests/*.py)
 	pep8 setup.py khmer/ scripts/ tests/ oxli/ \

=== doc/requirements.txt ===
sphinxcontrib-autoprogram>=0.1.4
setuptools>=3.4.1
guzzle_sphinx_theme==0.7.11

=== examples/c++-api/Makefile ===
CXXFLAGS=--std=c++11 \
       -I ../../include/ \
	   -I ../../third-party/smhasher \
	   -I ../../third-party/cqf \
	   -I ../../third-party/seqan/core/include/ \
	   -I ../../third-party/rollinghash

TESTS=exact-counting bloom consume

%: %.cc ../../src/oxli/liboxli.a
	$(CXX) $(CXXFLAGS) $< ../../src/oxli/liboxli.a -o $@

../../src/oxli/liboxli.a:
	cd ../../src/oxli && make

run: all
	./exact-counting
	./bloom
	./consume reads.fastq

all: $(TESTS)

clean:
	-rm -f exact-counting bloom consume

=== src/oxli/Makefile ===
--- 
+++ 
@@ -68,7 +68,9 @@
 ### NOTE: No user-serviceable parts below this line! ###
 
 INCLUDES= -I ../../include/ -I ../../third-party/seqan/core/include/ \
-	      -I ../../third-party/smhasher/
+	      -I ../../third-party/smhasher/ \
+				-I ../../third-party/cqf/ \
+				-I ../../third-party/rollinghash
 
 ifeq ($(USE_SYSTEM_ZLIB), false)
 INCLUDES += -I ../../third-party/zlib/
@@ -82,7 +84,7 @@
 WARNINGS=-Wall
 
 # Flags in common to C and C++
-COMMON_FLAGS=-O3 -fPIC
+COMMON_FLAGS=-O3 -fPIC -fno-omit-frame-pointer
 SEQAN_FLAGS=-DSEQAN_HAS_ZLIB=1 -DSEQAN_HAS_BZIP2=1
 
 # Base C/CXXFLAGS
@@ -218,6 +220,11 @@
 
 BZIP2_OBJS=$(addprefix $(BZIP2_DIR)/, $(BZIP2_OBJS_BASE))
 
+# Counting bloom filter
+CQF_DIR=../../third-party/cqf
+CQF_OBJS_BASE= gqf.o
+
+CQF_OBJS=$(addprefix $(CQF_DIR)/, $(CQF_OBJS_BASE))
 
 #### oxli proper below here ####
 
@@ -251,6 +258,10 @@
 PRECOMILE_OBJS += $(BZIP2_OBJS)
 PRECLEAN_TARGS += libbz2clean
 endif
+
+LIBOXLI_OBJS  += $(CQF_OBJS)
+PRECOMILE_OBJS += $(CQF_OBJS)
+PRECLEAN_TARGS += libcqfclean
 
 HEADERS= \
 	hashtable.hh \
@@ -279,6 +290,8 @@
 	(cd $(ZLIB_DIR) && make distclean)
 libbz2clean:
 	(cd $(BZIP2_DIR) && make -f Makefile-libbz2_so clean)
+libcqfclean:
+	(cd $(CQF_DIR) && make clean)
 
 clean: $(PRECLEAN_TARGS)
 	rm -f *.o *.a *.$(SHARED_EXT)* oxli.pc $(TEST_PROGS)
@@ -302,6 +315,9 @@
 $(BZIP2_OBJS):
 	(cd $(BZIP2_DIR) && make -f Makefile-libbz2_so $(BZIP2_OBJS_BASE))
 
+$(CQF_OBJS):
+	(cd $(CQF_DIR) && make)
+
 # MurMur3
 murmur3.o: ../../third-party/smhasher/MurmurHash3.cc
 	$(CXX) $(CXXFLAGS) -c -o $@ $<

=== third-party/cqf/Makefile ===
TARGETS=gqf.o

ifdef D
	DEBUG=-g
	OPT=
else
	DEBUG=
	OPT=-Ofast
endif

# using the SSE4.2 extensions doesn't seem to speed things up by a large
# amount, so disabling it for the time being till we have a good automated
# test for detecting whether or not the CPU supports it
OS := $(shell uname)
ifeq ($(OS), Darwin)
	ARCH=
else
	#ARCH=-msse4.2 -D__SSE4_2_
	ARCH=
endif

ifdef P
	PROFILE=-pg -no-pie # for bug in gprof.
endif

ifneq ($(INCLUDE),)
	INCLUDE := -I$(INCLUDE)
endif

CXX = g++ -std=c++11 -fPIC
CC = g++ -std=c++11 -fPIC
LD= g++ -std=c++11

CXXFLAGS = -Wall $(DEBUG) $(PROFILE) $(OPT) $(ARCH) -m64 -I. -Wno-unused-result -Wno-strict-aliasing -Wno-unused-function

LDFLAGS = $(DEBUG) $(PROFILE) $(OPT) -lpthread -lssl -lcrypto -lm

#
# declaration of dependencies
#

all: $(TARGETS)

# dependencies between programs and .o files



# dependencies between .o files and .cc (or .c) files

%.o: %.cc
gqf.o: gqf.c gqf.h

#
# generic build rules
#

%.o: %.cc
	$(CXX) $(CXXFLAGS) $(INCLUDE) $< -c -o $@

%.o: %.c
	$(CC) $(CXXFLAGS) $(INCLUDE) $< -c -o $@

clean:
	rm -f *.o $(TARGETS)

=== debian/changelog ===
khmer (3.0.0~a3+dfsg-9~0exp) experimental; urgency=medium

  * d/patches/non-x86-compat.patch: add support for non-x86 systems
  * d/control: build everywhere

 -- Michael R. Crusoe <crusoe@debian.org>  Sun, 18 Feb 2024 09:40:13 +0100

=== debian/control ===
Source: khmer
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Michael R. Crusoe <crusoe@debian.org>,
           Kevin Murray <spam@kdmurray.id.au>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-sequence-python3,
               dh-exec,
               python3-guzzle-sphinx-theme,
               python3,
               python3-dev,
               python3-all-dev,
               python3-setuptools,
               python3-screed,
               python3-pytest,
               python3-pytest-runner,
               python3-sphinx,
               python3-sphinxcontrib.autoprogram,
               cython3,
               zlib1g-dev,
               libbz2-dev,
               asciidoctor,
               rdfind
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/med-team/khmer
Vcs-Git: https://salsa.debian.org/med-team/khmer.git
Homepage: https://khmer.readthedocs.org
Rules-Requires-Root: no

Package: khmer-common
Architecture: all
Multi-Arch: foreign
Depends: file,
         ${misc:Depends},
         ${sphinxdoc:Depends},
         python3-guzzle-sphinx-theme
Built-Using: ${sphinxdoc:Built-Using}
Description: common files for the khmer project tools
 khmer is a library and suite of command line tools for working with DNA
 sequence. It is primarily aimed at short-read sequencing data such as
 that produced by the Illumina platform. khmer takes a k-mer-centric
 approach to sequence analysis, hence the name.
 .
 This package contains common files for liboxli and khmer

Package: khmer
Architecture: any
Multi-Arch: foreign
Depends: khmer-common,
         python3,
         python3-screed,
         ${shlibs:Depends},
         ${misc:Depends},
         ${python3:Depends}
Description: in-memory DNA sequence kmer counting, filtering & graph traversal
 khmer is a library and suite of command line tools for working with DNA
 sequence. It is primarily aimed at short-read sequencing data such as that
 produced by the Illumina platform. khmer takes a k-mer-centric approach to
 sequence analysis, hence the name.

Package: liboxli1
Architecture: any
Multi-Arch: same
Section: libs
Depends: khmer-common,
         ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: in-memory DNA sequence analysis library from the khmer project
 khmer is a library and suite of command line tools for working with DNA
 sequence. It is primarily aimed at short-read sequencing data such as that
 produced by the Illumina platform. khmer takes a k-mer-centric approach to
 sequence analysis, hence the name.
 .
 This package contains the low-level C++ library.

Package: liboxli-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: liboxli1 (= ${binary:Version}),
         ${misc:Depends},
         khmer-common
Description: in-memory DNA sequence analysis dev library
 khmer is a library and suite of command line tools for working with DNA
 sequence. It is primarily aimed at short-read sequencing data such as that
 produced by the Illumina platform. khmer takes a k-mer-centric approach to
 sequence analysis, hence the name.
 .
 This package contains the low-level C++ library headers and static archive.

=== debian/rules ===
--- 
+++ 
@@ -13,14 +13,15 @@
 export HOME=$(shell echo $$PWD"/fakehome")
 
 %:
-	dh $@ --with python3,sphinxdoc --buildsystem=pybuild
+	dh $@ --with sphinxdoc --buildsystem=pybuild
 
 override_dh_auto_build:
 	dh_auto_build
-	ln -sf "`pwd`"/.pybuild/pythonX.Y_*/build/khmer/*.so khmer && \
-		./setup.py develop --user && ./setup.py build_sphinx
+	ln -sf `pybuild --print build_dir|awk -F: '{print $$2}'`/khmer/*.so khmer && \
+		./setup.py develop --user && sphinx-build doc build/sphinx/html
 	asciidoctor --backend manpage -a reproducible debian/khmer.1.adoc
-	cd src/oxli && $(MAKE) clean all
+	$(MAKE) -C src/oxli clean
+	$(MAKE) -C src/oxli all USE_SYSTEM_ZLIB="true" USE_SYSTEM_LIBBZ2="true"
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=auto,repack,compression=xz,filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%,uversionmangle=s/a/~a/" \
  https://github.com/dib-lab/khmer/tags (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
